# Some make rules to make output pretty....

# default ARFLAGS also has 'v', but we don't want it to be verbose.
ARFLAGS= -r

# make sure libs from /usr/local/lib are found
VPATH= /lib64 /usr/lib64 /usr/local/lib64 /lib /usr/lib /usr/local/lib

%.o : %.c
	@echo "   CC  $<"
	@$(CC) -MD $(CFLAGS) -c $<

%: %.o
	@echo "   LD  $@"
	@$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) $($@_LDFLAGS) -o $@

(%): %
	@echo "   AR  $< in $@"
	@$(AR) $(ARFLAGS) $@ $<

%.tab.c %.tab.h: %.y
	@echo "BISON  $<"
	@bison -d $<

%.yy.h: %.l %.tab.h
	@echo " FLEX  $<"
	@flex --header-file=$*.yy.h $<

%.yy.c: %.l %.tab.h
	@echo " FLEX  $<"
	@flex -o $@ $<

# il2c: instruction list 2 c 'compiler'
%.c %.h: %.il
	@echo " IL2C  $<"
	@$(IL2C) $<

# dot -> pdf
%.pdf: %.dot
	@echo "  DOT  $<"
	@dot $< -o $@ -Tpdf

-include $(SRCS:.c=.d)
