/*
	dcc-cmd
	
	A simple DCC command station using the dcc-kiss interface.
	
	Copyright Jeroen Vreeken (jeroen@vreeken.net), 2010, 2011, 2012, 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef _INCLUDE_DCC_INTERFACE_H_
#define _INCLUDE_DCC_INTERFACE_H_

#include "dcc_cmd.h"

int dcc_send(int fd, unsigned char *packet, size_t length, struct dcc_address *address, bool wait_ack);
int dcc_send_real(int fd, unsigned char *packet, size_t length, struct dcc_address *address, bool wait_ack);
int dcc_send_lock(void);
int dcc_send_unlock(void);

int dcc_power(int fd, bool power);
int dcc_ack_flush(int fd);


#endif /* _INCLUDE_DCC_INTERFACE_H_ */
