/*
	dcc_srcpd.c
		
	SRCP implementation for a simple DCC command station

	Copyright Jeroen Vreeken (jeroen@vreeken.net), 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
 
#include "dcc_srcpd_description.h"


void dcc_srcpd_info_get_description_str(char *buffer, int bus)
{
	buffer = dcc_srcpd_rep_timestamp_str(buffer);
	if (bus == 0) {
		sprintf(buffer, "100 INFO 0 "
		    DCC_SRCPD_GROUP_DESCRIPTION " "
		    DCC_SRCPD_GROUP_SESSION " "
		    DCC_SRCPD_GROUP_GM" "
		    DCC_SRCPD_GROUP_SERVER "\n");
	} else if (bus == 1) {
		sprintf(buffer, "100 INFO 1 "
		    DCC_SRCPD_GROUP_DESCRIPTION " "
		    DCC_SRCPD_GROUP_GL " "
		    DCC_SRCPD_GROUP_GA " "
		    DCC_SRCPD_GROUP_SM " "
		    DCC_SRCPD_GROUP_LOCK " "
		    DCC_SRCPD_GROUP_POWER "\n");
	} else {
		sprintf(buffer, "%s\n",
		    DCC_SRCPD_REP_WRONG_VALUE);
	}
}

int dcc_srcpd_info_get_description(FILE *fd_sock, int bus)
{
	int r;
	char buffer[DCC_SRCPD_REQ_LEN];
	
	dcc_srcpd_info_get_description_str(buffer, bus);
	
	r = fprintf(fd_sock, buffer);
	
	if (r < 0)
		return -1;
	else
		return 0;
}

void dcc_srcpd_info_get_description_update(int bus)
{
	struct dcc_srcpd_info *info;

	info = dcc_srcpd_info_q_new();
	
	dcc_srcpd_info_get_description_str(info->buffer, bus);

	dcc_srcpd_info_q_add(info);
}

