/*
	dcc_srcpd.c
		
	SRCP implementation for a simple DCC command station

	Copyright Jeroen Vreeken (jeroen@vreeken.net), 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef _INCLUDE_DCC_SRCPD_INFO_Q_H_
#define _INCLUDE_DCC_SRCPD_INFO_Q_H_

#include "dcc_srcpd.h"

struct dcc_srcpd_info {
	struct dcc_srcpd_info *next;
	int refcount;
	char buffer[DCC_SRCPD_REQ_LEN];
	int dst_session_id;
};

struct dcc_srcpd_info *dcc_srcpd_info_q_new(void);
void dcc_srcpd_info_q_add(struct dcc_srcpd_info *entry);
struct dcc_srcpd_info *dcc_srcpd_info_q_get(struct dcc_srcpd_info *prev);
void dcc_srcpd_info_q_put(struct dcc_srcpd_info *prev);

void dcc_srcpd_info_q_client_add(void);
void dcc_srcpd_info_q_client_remove(void);


#endif /* _INCLUDE_DCC_SRCPD_INFO_Q_H_ */
