/*
	dcc_srcpd.c
		
	SRCP implementation for a simple DCC command station

	Copyright Jeroen Vreeken (jeroen@vreeken.net), 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef _INCLUDE_DCC_SRCPD_LOCK_STR_H_
#define _INCLUDE_DCC_SRCPD_LOCK_STR_H_
 
#include "dcc_cmd.h"
#include "dcc_srcpd.h"
#include "dcc_srcpd_info_q.h"
#include "dcc_decoder.h"

#include <stdio.h>
#include <stdbool.h>

void dcc_srcpd_lock_session_clean(int session_id);
bool dcc_srcpd_lock_term_gl(FILE *fd_sock, int session_id, struct dcc_decoder *decoder);
bool dcc_srcpd_lock_term_sm(FILE *fd_sock, int session_id, struct dcc_decoder *decoder);
bool dcc_srcpd_lock_term_ga(FILE *fd_sock, int session_id, struct dcc_accessory_decoder *decoder);
int dcc_srcpd_lock_get_gl(FILE *fd_sock, struct dcc_decoder *decoder);
int dcc_srcpd_lock_set_gl(FILE *fd_sock, struct dcc_decoder *decoder, int duration, int session_id);
int dcc_srcpd_lock_get_sm(FILE *fd_sock, struct dcc_decoder *decoder);
int dcc_srcpd_lock_set_sm(FILE *fd_sock, struct dcc_decoder *decoder, int duration, int session_id);
int dcc_srcpd_lock_get_ga(FILE *fd_sock, struct dcc_accessory_decoder *decoder);
int dcc_srcpd_lock_set_ga(FILE *fd_sock, struct dcc_accessory_decoder *decoder, int duration, int session_id);


#endif /* _INCLUDE_DCC_SRCPD_LOCK_H_ */
