/*
	dcc_srcpd.c
		
	SRCP implementation for a simple DCC command station

	Copyright Jeroen Vreeken (jeroen@vreeken.net), 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include "dcc_srcpd_session.h"

#include "dcc_srcpd_info_q.h"

void dcc_srcpd_info_get_session_str(char *buffer, int session_id)
{
	buffer = dcc_srcpd_rep_timestamp_str(buffer);
	sprintf(buffer, "100 INFO 0 SESSION %d\n", session_id);
}

void dcc_srcpd_info_term_session_str(char *buffer, int session_id)
{
	buffer = dcc_srcpd_rep_timestamp_str(buffer);
	sprintf(buffer, "102 INFO 0 SESSION %d\n", session_id);
}

void dcc_srcpd_info_init_session_str(char *buffer, int session_id)
{
	buffer = dcc_srcpd_rep_timestamp_str(buffer);
	sprintf(buffer, "101 INFO 0 SESSION %d\n", session_id);
}

int dcc_srcpd_info_get_session(FILE *fd_sock, int session_id)
{
	int r;
	char buffer[DCC_SRCPD_REQ_LEN];
	
	dcc_srcpd_info_get_session_str(buffer, session_id);
	
	r = fprintf(fd_sock, buffer);
	
	if (r < 0)
		return -1;
	else
		return 0;
}

void dcc_srcpd_info_get_session_update(int session_id)
{
	struct dcc_srcpd_info *info;
	char *buffer;

	info = dcc_srcpd_info_q_new();
	
	buffer = info->buffer;

	dcc_srcpd_info_get_session_str(buffer, session_id);

	dcc_srcpd_info_q_add(info);
}

void dcc_srcpd_info_init_session_update(int session_id)
{
	struct dcc_srcpd_info *info;
	char *buffer;

	info = dcc_srcpd_info_q_new();
	
	buffer = info->buffer;

	dcc_srcpd_info_init_session_str(buffer, session_id);

	dcc_srcpd_info_q_add(info);
}

void dcc_srcpd_info_term_session_update(int session_id)
{
	struct dcc_srcpd_info *info;
	char *buffer;

	info = dcc_srcpd_info_q_new();
	
	buffer = info->buffer;

	dcc_srcpd_info_term_session_str(buffer, session_id);

	dcc_srcpd_info_q_add(info);
}


